//
//  FollowersViewController.swift
//  VKExt
//
//  Created Ярослав Стрельников on 31.07.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import PanModal
import Material
import AsyncDisplayKit

class FollowersViewController: UIBaseTableNodeController, FollowersViewProtocol, PanModalPresentable {
	var presenter: FollowersPresenterProtocol?

    var dismissButton: IconButton = {
        let button = IconButton(image: UIImage(named: "dismiss_24")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableDarkGrayVK), tintColor: .adaptableDarkGrayVK)
        return button
    }()
    private var friendViewModel = FriendViewModel.init(cell: [], footerTitle: nil)
    private lazy var footerView = FooterView()
    var service: FriendsService?

    var panScrollable: UIScrollView? {
        return nil
    }
    
    var panModalBackgroundColor: UIColor {
        return UIColor.black.withAlphaComponent(0.35)
    }
    
    var shortFormHeight: PanModalHeight {
        return .contentHeight(screenHeight / 1.5)
    }
    
    var longFormHeight: PanModalHeight {
        return .maxHeightWithTopInset(getCommonInset(by: [.statusbar]))
    }
    
    var showDragIndicator: Bool {
        return false
    }
    
    var anchorModalToLongForm: Bool {
        return true
    }
    
    var shouldRoundTopCorners: Bool {
        return true
    }
    
    var cornerRadius: CGFloat {
        return 14
    }
    
    var springDamping: CGFloat {
        return 1
    }
    
    var transitionDuration: Double {
        return 0.45
    }
    
    var transitionAnimationOptions: UIView.AnimationOptions {
        return [.curveEaseOut, .allowUserInteraction, .beginFromCurrentState, .preferredFramesPerSecond60]
    }
    
    var userId: Int?
    
    init(userId: Int) {
        super.init(nibName: nil, bundle: nil)
        self.userId = userId
        FollowersRouter.createModule(self)
        presenter?.start(request: .getFollowers(userId: userId))
    }
    
    required init?(coder: NSCoder) {
        super.init(coder: coder)
    }
    
	override func viewDidLoad() {
        super.viewDidLoad()
        view.backgroundColor = .adaptableWhite
        prepareTable()
        setupTable()
        prepareToolbar(fonts: [GoogleSansFont.bold(with: 21), GoogleSansFont.regular(with: 13)])
    }
    
    func setupToolbar(title: String, subtitle: String, leftViews: [UIView]?, rightViews: [UIView]?) {
        toolbar.title = title
        toolbar.detail = subtitle
        if let leftViews = leftViews {
            toolbar.leftViews = leftViews
        }
        if let rightViews = rightViews {
            toolbar.rightViews = rightViews
        }
    }
    
    func setupTable() {
        mainTableNode.contentInset.top = -40
        mainTableNode.view.prepareBackground()
        mainTableNode.view.keyboardDismissMode = .onDrag
        mainTableNode.delegate = self
        mainTableNode.dataSource = self
        mainTableNode.view.tableFooterView = footerView
        refreshControl.addTarget(self, action: #selector(refreshTable(_:)), for: UIControl.Event.valueChanged)
        topConstraint?.constant = getCommonInset(by: [.toolbar])
    }
    
    func displayData(viewModel: FriendModel.ViewModel.ViewModelData) {
        switch viewModel {
        case .displayFriend(friendViewModel: let friendViewModel):
            self.friendViewModel = friendViewModel
            mainTableNode.reloadData()
            setupToolbar(title: "Подписчики", subtitle: "", leftViews: nil, rightViews: [dismissButton])
            refreshControl.endRefreshing()
            let friendsCount = friendViewModel.cell.count > 0 ? "\(friendViewModel.cell.count) \(getStringByDeclension(number: friendViewModel.cell.count, arrayWords: Localization.instance.followersString))" : "Нет подписчиков"
            footerView.setTitle(friendsCount)
        case .displayFooterLoader:
            footerView.setTitle("")
            footerView.showLoader()
        case .displayFooterError(message: let message):
            toolbar.title = "Ошибка загрузки"
            footerView.setTitle(message)
            mainTableNode.reloadData()
            refreshControl.endRefreshing()
        }
    }
    
    @objc func refreshTable(_ sender: Any?) {
    }
    
    func showErrorConnection() {
        mainTableNode.reloadData()
        mainTableNode.toggleNoMessagesNote(on: true, with: "Проблема с подключением", at: "no_connection")
    }
}
extension FollowersViewController: ASTableDelegate, ASTableDataSource {
    func scrollViewDidEndDragging(_ scrollView: UIScrollView, willDecelerate decelerate: Bool) {
        if scrollView.contentOffset.y > scrollView.contentSize.height / 1.5 {
            presenter?.start(request: .getNextFollowers(userId: userId ?? VKConstants.currentUserId))
        }
    }

    func tableNode(_ tableNode: ASTableNode, numberOfRowsInSection section: Int) -> Int {
        return friendViewModel.cell.count
    }
    
    func numberOfSections(in tableNode: ASTableNode) -> Int {
        return 1
    }
    
    func tableNode(_ tableNode: ASTableNode, nodeBlockForRowAt indexPath: IndexPath) -> ASCellNodeBlock {
        var node: ASCellNode
        node = FollowerCellNode(by: friendViewModel.cell[indexPath.row])
        node.selectionStyle = .none
        return { () -> ASCellNode in
            return node
        }
    }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        return 0
    }
    
    func tableNode(_ tableNode: ASTableNode, constrainedSizeForRowAt indexPath: IndexPath) -> ASSizeRange {
        let screenSize = Screen.bounds.width
        let minSize: CGSize = CGSize(width: screenSize, height: 48)
        let maxSize: CGSize = minSize
        return ASSizeRange(min: minSize, max: maxSize)
    }
}
